%define ENABLE_SNMP_SUBAGENT 0
%define ENABLE_MGMT 1
%define gname haclient
%define uname hacluster
# XXX FIXME!
%define _localstatedir %_var

%def_disable static

Summary: Heartbeat subsystem for High-Availability Linux
Name: heartbeat
Version: 2.0.7
Release: alt2.1
License: GPL/LGPL
Url: http://linux-ha.org/
Group: System/Servers
Source0: http://linux-ha.org/download/%name-%version.tar
Source1: heartbeat.init.alt
Source2: ldirectord.init.alt
# ALTLinux patches
Patch0: heartbeat-alt-pam.patch
Patch1: heartbeat-alt-build.patch
Patch2: heartbeat-alt-deps.patch

BuildRequires(pre): rpm-build-linux-ha

BuildRequires: glib2-devel, iputils, openssl-devel, libnet-devel, libltdl-devel, libnet-snmp-devel, libwrap-devel, bzip2-devel, zlib-devel, libe2fs-devel, flex, libncurses-devel
%if %ENABLE_MGMT
BuildRequires: libgnutls-devel, libtasn1-devel, libpam0-devel, python-devel, swig, libxml2-devel
Requires: gettext
%endif
Requires: stonith = %version-%release
Requires: pils = %version-%release
Requires: ldirectord = %version-%release
Requires: python-module-pygtk >= 2.4
Requires: %_ha_dir

# XXX hack for /usr/lib/ocf/resource.d/heartbeat/ClusterMon
Provides: %_libdir/%name/crm_mon
# XXX hack for findreq-python
%add_python_req_skip _pymgmt

%description
heartbeat is a basic high-availability subsystem for Linux-HA.
It will run scripts at initialization, and when machines go up or down.
This version will also perform IP address takeover using gratuitous ARPs.
It supports "n-node" clusters with significant capabilities for managing
resources and dependencies.

In addition it continues to support the older release 1 style of
2-node clustering.

It implements the following kinds of heartbeats:
        - Serial ports
        - UDP/IP multicast (ethernet, etc)
        - UDP/IP broadcast (ethernet, etc)
        - UDP/IP heartbeats
        - "ping" heartbeats (for routers, switches, etc.)
           (to be used for breaking ties in 2-node systems)

%package -n ldirectord
Summary: Monitor daemon for maintaining high availability resources
Group: System/Servers
Requires: ipvsadm, %_ha_resource_dir
BuildRequires: perl-devel, perl-libwww, perl-HTML-Parser, perl-Net-SSLeay, perl-ldap, perl-Net-Ping, perl-MailTools

%description -n ldirectord
ldirectord is a stand-alone daemon to monitor services of real
for virtual services provided by The Linux Virtual Server
(http://www.linuxvirtualserver.org/). It is simple to install
and works with the heartbeat code (http://www.linux-ha.org/).

%package -n stonith
Requires: pils = %version-%release
Summary: Provides an interface to Shoot The Other Node In The Head
Group: System/Servers

%description -n stonith
The STONITH module (a.k.a. STOMITH) provides an extensible interface
for remotely powering down a node in the cluster.  The idea is quite simple:
When the software running on one machine wants to make sure another
machine in the cluster is not using a resource, pull the plug on the other
machine. It's simple and reliable, albeit admittedly brutal.

%package -n pils
Summary: Provides a general plugin and interface loading library
Group: System/Servers

%description -n pils
PILS is an generalized and portable open source Plugin and Interface Loading
System. PILS was developed as part of the Open Cluster Framework reference
implementation, and is designed to be directly usable by a wide variety of
other applications.
PILS manages both plugins (loadable objects), and the interfaces these plugins
implement. PILS is designed to support any number of plugins implementing any
number of interfaces.

%package devel
Summary: Heartbeat development package
Group: Development/C
Requires: heartbeat = %version-%release

%description devel
Heartbeat development package.

%package devel-static
Summary: Heartbeat static libs
Group: Development/C

%description devel-static
Heartbeat static libs.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
%__autoreconf
# disable-fatal-warnings flag used to disable gcc4.x warnings of 'difference in signedness'
CFLAGS="%optflags" \
%configure \
  --disable-fatal-warnings \
%if %ENABLE_MGMT
  --enable-mgmt \
%else
  --disable-mgmt \
%endif
  %{subst_enable static} 
make

%install
%set_verify_elf_method unresolved=relaxed
%__make install DESTDIR=%buildroot
(
  cd %buildroot/etc/ha.d/resource.d
  %__ln_s %_sbindir/ldirectord ldirectord
)

# cleanup
[ -d %buildroot%_initrddir ] && rm -rf %buildroot%_initrddir/*
[ -d %buildroot/usr/man ] && rm -rf %buildroot/usr/man
[ -d %buildroot/usr/share/libtool ] && rm -rf %buildroot/usr/share/libtool
find %buildroot -type f -name *.la -exec rm -f {} ';'

%__subst '1i# -*-Shell-script-*-' %buildroot%_libdir/heartbeat/ocf-shellfuncs
%__subst '1i# -*-Shell-script-*-' %buildroot%_sysconfdir/ha.d/shellfuncs
chmod -x %buildroot%_libdir/heartbeat/ocf-shellfuncs
chmod -x %buildroot%_sysconfdir/ha.d/shellfuncs
chmod -x %buildroot%_libdir/heartbeat/pymgmt.py
%__install -pD -m755 %SOURCE1 %buildroot%_initrddir/heartbeat
%__install -pD -m755 %SOURCE2 %buildroot%_initrddir/ldirectord


%pre
/usr/sbin/groupadd -r -f %gname &>/dev/null || :
/usr/sbin/useradd -r -n -s /dev/null -d %_localstatedir/lib/heartbeat/cores/hacluster -M \
        -c 'heartbeat user' -g %gname %uname &>/dev/null || :

%post
%post_ldconfig
%post_service heartbeat

%preun
%preun_service heartbeat

%postun
%postun_ldconfig

%post -n ldirectord
%post_service ldirectord

%preun -n ldirectord
%preun_service ldirectord

%post -n stonith -p %post_ldconfig

%postun -n stonith -p %postun_ldconfig

%files
%doc %_datadir/doc/%name-%version
%_ha_dir/harc
%config(noreplace) %_ha_dir/shellfuncs
%_ha_dir/rc.d
%config(noreplace) %_ha_dir/README.config
%_ha_resource_dir/hto-mapfuncs
%_ha_resource_dir/Filesystem
%_libdir/heartbeat
%_libdir/libapphb.so.*
%_libdir/libccmclient.so.*
%_libdir/libcib.so.*
%_libdir/libclm.so.*
%_libdir/libcrmcommon.so.*
%_libdir/libhbclient.so.*
%_libdir/liblrm.so.*
%_libdir/libpengine.so.*
%_libdir/libplumb.so.*
%_libdir/libplumbgpl.so.*
%_libdir/librecoverymgr.so.*
%_libdir/libstonithd.so.*
%prefix/lib/ocf
%_initrddir/heartbeat
%config(noreplace) %_sysconfdir/logrotate.d/heartbeat
%dir %_localstatedir/lib/heartbeat
%dir %_localstatedir/lib/heartbeat/cores
%dir %attr (0755, root, root) %_localstatedir/lib/heartbeat/cores/root
%dir %attr (0755, nobody, nobody) %_localstatedir/lib/heartbeat/cores/nobody
%dir %attr (0755, hacluster, haclient) %_localstatedir/lib/heartbeat/cores/hacluster
%dir %_var/run/heartbeat
%attr (0755, hacluster, haclient) %_bindir/cl_status
%_bindir/cl_respawn
%_sbindir/attrd_updater
%_sbindir/crmadmin
%_sbindir/cibadmin
%_sbindir/ccm_tool
%_sbindir/crm_diff
%_sbindir/crm_uuid
%_sbindir/crm_mon
%_sbindir/iso8601
%_sbindir/crm_master
%_sbindir/crm_standby
%_sbindir/crm_attribute
%_sbindir/crm_resource
%_sbindir/crm_verify
%_sbindir/crm_failcount
%_sbindir/crm_primitive.py
%dir %attr (755, hacluster, haclient) %_var/run/heartbeat/ccm
%dir %attr (755, hacluster, haclient) %_var/run/heartbeat/crm
%dir %attr (755, hacluster, haclient) %_localstatedir/lib/heartbeat/crm
%_man1dir/cl_status.1*
%_man1dir/ha_logger.1*
%_man1dir/hb_standby.1*
%_man1dir/hb_takeover.1*
%_man1dir/hb_addnode.1*
%_man1dir/hb_delnode.1*
%_man8dir/heartbeat.8*
%_man8dir/apphbd.8*
%_man8dir/ha_logd.8*
%_man8dir/cibadmin.8*
%if %ENABLE_SNMP_SUBAGENT
/LINUX-HA-MIB.mib
%endif
%if %ENABLE_MGMT
%_libdir/libhbmgmt.so.*
%_libdir/libhbmgmtclient.so.*
%_libdir/libhbmgmtcommon.so.*
%_libdir/libhbmgmttls.so.*
%config(noreplace) %_sysconfdir/pam.d/hbmgmtd
%_datadir/locale/zh_CN/LC_MESSAGES/*
%endif

%files -n ldirectord
%doc doc/COPYING
%doc doc/README
%doc ldirectord/ldirectord.cf
%_initrddir/ldirectord
%_ha_dir/conf
%_ha_resource_dir/ldirectord
%_sbindir/ldirectord
%_sbindir/supervise-ldirectord-config
%config(noreplace) %_sysconfdir/logrotate.d/ldirectord
%_man8dir/ldirectord.8*
%_man8dir/supervise-ldirectord-config.8*

%files -n stonith
%doc doc/COPYING
%doc doc/README

%_libdir/*.so.*
%_libdir/stonith/
%_sbindir/stonith
%_sbindir/meatclient
%_man8dir/stonith.8*
%_man8dir/meatclient.8*

%files -n pils
%doc doc/COPYING
%doc doc/README

%_libdir/pils/

%files devel
%doc %_datadir/doc/%name-%version

%_includedir/heartbeat/
%_includedir/clplumbing/
%_includedir/saf/
%_includedir/ocf/
%_includedir/stonith/
%_includedir/pils/
%_libdir/*.so

%if_enabled static
%files devel-static
%_libdir/*.a
%endif #static

%changelog
* Tue Dec 19 2006 L.A. Kostis <lakostis@altlinux.ru> 2.0.7-alt2.1
- Apply patch from Eugene Prokopiev <enp (fix for altbug #10455):
  - add %_ha_resource_dir/hto-mapfuncs and %_ha_resource_dir/Filesystem to
    heartbeat package

* Sat Dec 02 2006 L.A. Kostis <lakostis@altlinux.ru> 2.0.7-alt2
- release for Sisyphus.
- add dependency to linux-ha-common and remove directory intersections.
- Added patches: 
  + heartbeat-alt-deps.patch - remove extra deps from BuildChecks scripts 
    (tnx to Eugene Prokopiev);

* Wed Sep 27 2006 L.A. Kostis <lakostis@altlinux.ru> 2.0.7-alt1
- Version 2.0.7.
- remove obsoleted patches from Fedora.
- update -alt-build patch.
- update .spec for new files/layout changes.
- update buildrequires.

* Sun Apr 23 2006 LAKostis <lakostis at altlinux.org> 2.0.4-alt1
- First build for ALTLinux;
- fix build with --as-needed;
- rewrite/cleanup init.d scripts (FIXME! need more work);
- .spec based on 2.0.4-2 FC6 package.

